/*
#  C.E.A. IRFU/SIS/LDISC
#
*/

program homeMtrAuto

%%#include <stdio.h>
%%#include <string.h>
%%#include <stdlib.h>

/**** MTR PV ******/
short HOMCPTFLAG;
assign HOMCPTFLAG to "{PMACPREFIX}:{MOTOR_NAME1}-HOMCPTFLAG";
monitor HOMCPTFLAG;

short homeCMD;
assign homeCMD to "{PMACPREFIX}:{MOTOR_NAME1}-HOMCMD";
monitor homeCMD;

short brakeMtrCMD;
assign brakeMtrCMD to "{PREFIX}:PBI-EM:VER-BRAKE_SET";
monitor brakeMtrCMD;

short brakeMtrGET;
assign brakeMtrGET to "{PREFIX}:PBI-EM:VER-BRAKE_GET";
monitor brakeMtrGET;
evflag brakeMtrGETEvent;
sync brakeMtrGET brakeMtrGETEvent;

/**** PV to start procedure ******/
short homeSTART;
assign homeSTART to "{DEVICE}:PROC-AUTO-HOME";
monitor homeSTART;
evflag homeSTARTEvent;
sync homeSTART homeSTARTEvent;

/**** PV to read the PLIM status ******/
short plimSTATUS;
assign plimSTATUS to "{PMACPREFIX}:{MOTOR_NAME1}.HLS";
monitor plimSTATUS;
evflag plimSTATUSEvent;
sync plimSTATUS plimSTATUSEvent;

ss ss1
{
	state init {
	    	      when (delay(1.0) && (pvConnectCount() == pvChannelCount())) 
					{
					homeSTART=0;
				        pvPut(homeSTART);
					} state start
		   }
	
	state start
		   {
			when(efTestAndClear(homeSTARTEvent)&&(homeSTART==1))
				{
				brakeMtrCMD=0;
				pvPut(brakeMtrCMD);
				HOMCPTFLAG=1; // PLIM
				pvPut(HOMCPTFLAG);
				homeCMD=1;
				pvPut(homeCMD);
				}state home
		    }

	state home
		   {
			when(efTestAndClear(plimSTATUSEvent)&&(plimSTATUS==1))
				{
				HOMCPTFLAG=0; // HOME
				pvPut(HOMCPTFLAG);
				}state stop
		   }

	state stop
		   {
			when(delay(2))
				{
				homeCMD=1;
				pvPut(homeCMD);
				homeSTART=0;
				pvPut(homeSTART);
				brakeMtrCMD=1;
				pvPut(brakeMtrCMD);
				}state start
                   }

}

